﻿package 
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import org.si.sion.SiONData;
	import org.si.sion.SiONDriver;
	import org.si.sion.events.SiONEvent;
	import org.si.sion.events.SiONTrackEvent;

	public class Main extends Sprite
	{
		var sionDriver:SiONDriver;
		var kaeruData:SiONData;
		var KaeruList:Array = [];
		var rippleList:Array = [];
		var cnt:int = 0;
		var isEnd:Boolean = false;

		public function Main()
		{

			//1）カエルMCの用意
			KaeruList = [Do,DoSharp,Re,ReSharp,Mi,Fa,FaSharp,So,SoSharp,Ra,RaSharp,Shi];

			//2）ドライバの設定
			sionDriver = new SiONDriver(2048,2);

			//3）SiONDataにイベントを設定
			kaeruData = sionDriver.compile("#EFFECT1{delay};%t0,1,1 t100 @v32,16 l8 o6 cdefedcr efgagfer [c4]4 l16ccddeeff l8edcr");

			//4）イベントリスナーを登録
			sionDriver.addEventListener(SiONTrackEvent.BEAT,_onBeat);
			//拍子;

			sionDriver.addEventListener(SiONTrackEvent.NOTE_ON_FRAME,_onNoteOn);
			//発音;

			sionDriver.addEventListener(SiONTrackEvent.NOTE_OFF_FRAME,_onNoteOFF);
			//消音;

			sionDriver.addEventListener(SiONEvent.FINISH_SEQUENCE,_onFinishSequence);
			//演奏終了;

			//拍にあわせて波紋を出すために用意したMCリスト
			rippleList = [ripple1,ripple2,ripple3];
			
			//SiONTrackEvent.BEATイベントの発行間隔を設定　1～16
			sionDriver.setBeatCallbackInterval(4);
			//　16/4音符間隔;

			playBtn.addEventListener(MouseEvent.CLICK,fn_click);
			playBtn.buttonMode = true;

		}
		private function _onBeat(e:SiONTrackEvent):void
		{
			if (! isEnd)
			{
				if (cnt < 2)
				{
					cnt++;
				}
				else
				{
					cnt = 0;
				}
				rippleList[cnt].gotoAndPlay(1);
			}
		}

		private function _onNoteOn(e:SiONTrackEvent):void
		{
			var index:int = e.note % 12;
			KaeruList[index].gotoAndStop(2);
		}

		private function _onNoteOFF(e:SiONTrackEvent):void
		{
			var index:int = e.note % 12;
			KaeruList[index].gotoAndStop(1);
		}

		private function _onFinishSequence(e:SiONEvent):void
		{
			var index:int;
			for (index=0; index<12; index++)
			{
				KaeruList[index].gotoAndStop(2);
			}
			cnt = 0;
			isEnd = true;
			playBtn.visible = true;
		}

		private function fn_click(e:MouseEvent)
		{
			var index:int;
			for (index=0; index<12; index++)
			{
				KaeruList[index].gotoAndStop(1);
			}
			isEnd = false;
			e.target.visible = false;
			sionDriver.play(kaeruData);
		}

	}
}