﻿
package 
{
	import flash.display.Sprite;
	import flash.events.MouseEvent;
	import flash.events.KeyboardEvent;

	//import org.si.sion.SiONData;
	import org.si.sion.SiONDriver;
	import org.si.sion.events.SiONEvent;
	import org.si.sion.events.SiONTrackEvent;
	import org.si.sion.SiONVoice;
	import flash.display.MovieClip;
	import org.si.sion.utils.SiONPresetVoice;
	import org.si.sion.sequencer.SiMMLTrack;

	public class Main extends Sprite
	{
		public var sionDriver:SiONDriver;
		public var kaeruList:Array;
		public var presetVoiceList:SiONPresetVoice;
		public var pianoVoice:SiONVoice;
		public var track:SiMMLTrack;

		public function Main()
		{
			kaeruList = [Do,DoSharp,Re,ReSharp,Mi,Fa,FaSharp,So,SoSharp,Ra,RaSharp,Shi];

			var i:int = 0;

			for (i = 0; i < kaeruList.length; i++)
			{
				//MIDIノートナンバーは、60から開始される
				kaeruList[i].noteNumber = i + 60;
				kaeruList[i].addEventListener(MouseEvent.CLICK,_onClick);
				kaeruList[i].buttonMode = true;
			}

			sionDriver = new SiONDriver(2048,2);

			// プリセット音色リストの生成
			presetVoiceList = new SiONPresetVoice  ;

			//音色キーを用いて音色設定（SiONVoice）の取得
			//pianoVoice = presetVoiceList["midi.piano1"];
			pianoVoice = presetVoiceList["midi.drum24"];
			

			//消音;
			sionDriver.addEventListener(SiONTrackEvent.NOTE_OFF_FRAME,_onNoteOFF);


			//音の合成開始
			sionDriver.play();

			stage.addEventListener(KeyboardEvent.KEY_DOWN,fn_keyDown);
		}

		private function _onClick(e:MouseEvent):void
		{
			// クリックされたカエルインスタンスの取得
			var kaeru:MovieClip = e.target as MovieClip;
			// ノートナンバーの取得
			var noteNumber:int = kaeru.noteNumber;
			
			//指定番号を発音
			sionDriver.noteOn(noteNumber,pianoVoice,4,0,0);

			kaeru.gotoAndStop(2);

			// 指定ノート番号の音を発音．発音するトラックを返値で取得
			track = sionDriver.noteOn(noteNumber,pianoVoice,4,0,0);

			// トラックのイベントトリガーの設定 (ID、発音設定、消音設定)
			track.setEventTrigger(0,1,1);

			//音量
			track.velocity = 128;

		}

		private function fn_keyDown(e:KeyboardEvent):void
		{
			var setNum:int = 59;
			switch (e.keyCode)
			{
				case 90 ://Z
					setNum +=  1;//ド
					break;

				case 83 ://S
					setNum +=  2;//ド#
					break;
				case 88 ://X
					setNum +=  3;//レ
					break;

				case 68 ://D
					setNum +=  4;//レ#
					break;

				case 67 ://C
					setNum +=  5;//ミ
					break;

				case 86 ://V
					setNum +=  6;//ファ
					break;


				case 71 ://G
					setNum +=  7;//ファ#
					break;


				case 66 ://B
					setNum +=  8;//ソ
					break;

				case 72 ://H
					setNum +=  9;//ソ#
					break;


				case 78 ://N
					setNum +=  10;//ラ
					break;

				case 74 ://J
					setNum +=  11;//ラ#
					break;

				case 77 ://M
					setNum +=  12;//シ
					break;

				case 188 :// <
					setNum +=  13;//ド

					break;
			}
			if (setNum > 59)
			{
				sionDriver.noteOn(setNum,pianoVoice,4,0,0);
				kaeruList[setNum - 60].gotoAndStop(2);
				track = sionDriver.noteOn(setNum,pianoVoice,4,0,0);
				track.setEventTrigger(0,1,1);
				track.velocity = 255;
			}
		}

		private function _onNoteOFF(e:SiONTrackEvent):void
		{

			var index:int = e.note % 12;
			kaeruList[index].gotoAndStop(1);
		}


	}

}













/**/